--[[ addon functions ]]

function CritlineSettings_OnLoad(self)
	self.name = "Critline"
	InterfaceOptions_AddCategory(self)
	InterfaceOptions_AddCategory(_G[self:GetName().."Basic"])
	InterfaceOptions_AddCategory(_G[self:GetName().."Advanced"])
	

	self:RegisterEvent("ADDON_LOADED")

	SlashCmdList["CRITLINESETTINGS"] = function(msg)
		InterfaceOptionsFrame_OpenToCategory(CritlineSettings_FrameBasic)
	end
	
	SLASH_CRITLINESETTINGS1 = "/critline"
end


function CritlineSettings_OnEvent(self, event, ...)
	if (event == "ADDON_LOADED" and select(1, ...) == "Critline") then
		CritlineSettings_LoadSettings()
	end
end


function CritlineSettings_LoadSettings()
	local basicOptions = {
		{
			text = CL_OPTION_RECORD_DMG_TEXT,
			tooltipText = CL_OPTION_RECORD_DMG_TOOLTIPTEXT,
			setting = "DMG",
		},
		{
			text = CL_OPTION_RECORD_HEAL_TEXT,
			tooltipText = CL_OPTION_RECORD_HEAL_TOOLTIPTEXT,
			setting = "HEAL",
		},
		{
			text = CL_OPTION_RECORD_PET_TEXT,
			tooltipText = CL_OPTION_RECORD_PET_TOOLTIPTEXT,
			setting = "PET",
		},
		{
			text = CL_OPTION_RECORDPVE_TEXT,
			tooltipText = CL_OPTION_RECORDPVE_TOOLTIPTEXT,
			setting = "RECORDPVE",
		},
		{
			text = CL_OPTION_RECORDPVP_TEXT,
			tooltipText = CL_OPTION_RECORDPVP_TOOLTIPTEXT,
			setting = "RECORDPVP",
		},
		{
			text = CL_OPTION_PLAYSOUNDS_TEXT,
			tooltipText = CL_OPTION_PLAYSOUNDS_TOOLTIPTEXT,
			setting = "PLAYSOUNDS",
		},
		{
			text = CL_OPTION_SCREENCAP_TEXT,
			tooltipText = CL_OPTION_SCREENCAP_TOOLTIPTEXT,
			setting = "SNAPSHOT",
		},
		{
			text = CL_OPTION_SHOWDMG_TEXT,
			tooltipText = CL_OPTION_SHOWDMG_TOOLTIPTEXT,
			setting = "SHOWDMG",
		},
		{
			text = CL_OPTION_SHOWHEAL_TEXT,
			tooltipText = CL_OPTION_SHOWHEAL_TOOLTIPTEXT,
			setting = "SHOWHEAL",
		},
		{
			text = CL_OPTION_SHOWPET_TEXT,
			tooltipText = CL_OPTION_SHOWPET_TOOLTIPTEXT,
			setting = "SHOWPET",
		},
		{
			text = CL_OPTION_SUPPRESSMC_TEXT,
			tooltipText = CL_OPTION_SUPPRESSMC_TOOLTIPTEXT,
			setting = "SUPPRESSMC",
		},
		{
			text = CL_OPTION_DETAILED_TEXT,
			tooltipText = CL_OPTION_DETAILED_TOOLTIPTEXT,
			setting = "DETAILED",
		},
	}
	
	local name, option
	
	for i, v in ipairs(basicOptions) do
		name = "CritlineSettings_FrameBasic_Option"..i
		option = _G[name]
		_G[name.."Text"]:SetText(v.text)
		option.tooltipText = v.tooltipText
		option.setting = v.setting
		option:SetChecked(CL_SETTINGS[v.setting])
	end
	
	CritlineSettings_FrameBasic_Slider1:SetValue(CL_SETTINGS["LVLADJ"])
	
	--TODO: ADD BIG BUTTONS TO GENERIC TEMPLATE
	
	local advancedOptions = {
		{
			text = CL_OPTION_SHOWMINIMAP_TEXT,
			tooltipText = CL_OPTION_SHOWMINIMAP_TOOLTIPTEXT,
			setting = "SHOWMINIMAP",
		},
		{
			text = CL_OPTION_SPLASH_TEXT,
			tooltipText = CL_OPTION_SPLASH_TOOLTIPTEXT,
			setting = "SPLASH",
		},
		{
			text = CL_OPTION_MOVESPLASH_TEXT,
			tooltipText = CL_OPTION_MOVESPLASH_TOOLTIPTEXT,
			setting = "MOVESPLASH",
		},
		{
			text = CL_OPTION_INVERTDMG_TEXT,
			tooltipText = CL_OPTION_INVERTDMG_TOOLTIPTEXT,
			setting = "INVERTDMG",
		},
		{
			text = CL_OPTION_INVERTHEAL_TEXT,
			tooltipText = CL_OPTION_INVERTHEAL_TOOLTIPTEXT,
			setting = "INVERTHEAL",
		},
		{
			text = CL_OPTION_INVERTPET_TEXT,
			tooltipText = CL_OPTION_INVERTPET_TOOLTIPTEXT,
			setting = "INVERTPET",
		},
		{
			text = CL_OPTION_DONTFILTERMAGIC_TEXT,
			tooltipText = CL_OPTION_DONTFILTERMAGIC_TOOLTIPTEXT,
			setting = "DONTFILTERMAGIC",
		},
	}
	
	for i, v in ipairs(advancedOptions) do
		name = "CritlineSettings_FrameAdvanced_Option"..i
		option = _G[name]
		_G[name.."Text"]:SetText(v.text)
		option.tooltipText = v.tooltipText
		option.setting = v.setting
		option:SetChecked((i == 3) and false or CL_SETTINGS[v.setting])
	end
	
	CritlineSettings_FrameAdvanced_Slider1:SetValue(CL_SETTINGS["SCALE"])
	CritlineSettings_FrameAdvanced_Slider2:SetValue(CL_SETTINGS["SPLASHSCALE"])
	CritlineSettings_FrameAdvanced_Slider3:SetValue(CL_SETTINGS["SPLASHTIMER"])

	local swatch = CritlineSettings_FrameAdvancedColor1Swatch
	swatch.r = CL_SETTINGS["SPELLCOLOR"]["r"]
	swatch.g = CL_SETTINGS["SPELLCOLOR"]["g"]
	swatch.b = CL_SETTINGS["SPELLCOLOR"]["b"]
	swatch:SetVertexColor(swatch.r, swatch.g, swatch.b)
	CritlineSettings_FrameAdvancedColor1.tooltipText = CL_OPTION_SPLASHSPELLCOLOR_TOOLTIPTEXT

	CritlineSettings_FrameAdvancedColor1Text:SetText("Spell Color")
	
	local swatch = CritlineSettings_FrameAdvancedColor2Swatch
	swatch.r = CL_SETTINGS["AMOUNTCOLOR"]["r"]
	swatch.g = CL_SETTINGS["AMOUNTCOLOR"]["g"]
	swatch.b = CL_SETTINGS["AMOUNTCOLOR"]["b"]
	swatch:SetVertexColor(swatch.r, swatch.g, swatch.b)
	CritlineSettings_FrameAdvancedColor2.tooltipText = CL_OPTION_SPLASHAMOUNTCOLOR_TOOLTIPTEXT
	
	CritlineSettings_FrameAdvancedColor2Text:SetText("Amount Color")
end


function CritlineSettings_ResetRecords()
	Critline_DataReset()
end


function CritlineSettings_Button_OnClick(self)
	Critline_Debug(self.setting.." toggled.")
	if self.Setting == "MOVESPLASH" then -- temporary setting....not to be saved
		if self:GetChecked() then
			CritlineSplashFrame.locked = false
			CritlineSplashFrame:EnableMouse(1)
		else
			CritlineSplashFrame.locked = true
			CritlineSplashFrame:EnableMouse(0)
			CritlineSplashFrame:Clear()
		end
	else
		if self:GetChecked() then
			CL_SETTINGS[self.setting] = 1
		else
			CL_SETTINGS[self.setting] = 0
		end
		if (self.setting == "SHOWDMG" or self.setting == "SHOWHEAL" or self.setting == "SHOWPET") then
			CritlineDisplay_UpdateTree(strsub(self.setting, 5), self:GetChecked())
		end
		if (self.setting == "DETAILED") or (self.setting == "INVERTDMG") or (self.setting == "INVERTHEAL") or (self.setting == "INVERTPET") then
			Critline_RebuildAllTooltips()
		end
		if (self.setting == "SHOWMINIMAP") then
			if (self:GetChecked()) then
				CritlineMinimapFrame:Show()
			else
				CritlineMinimapFrame:Hide()
			end
		end
	end
end


local CritlineSettings_CancelFunc = {
	[1] = function(x) CritlineSettings_CancelColor(1, x) end,
	[2] = function(x) CritlineSettings_CancelColor(2, x) end,
	[3] = function(x) CritlineSettings_CancelColor(3, x) end,
	[4] = function(x) CritlineSettings_CancelColor(4, x) end,
	[5] = function(x) CritlineSettings_CancelColor(5, x) end,
	[6] = function(x) CritlineSettings_CancelColor(6, x) end
}

local CritlineSettings_SetColorFunc = {
	[1] = function() CritlineSettings_SetColor(1) end,
	[2] = function() CritlineSettings_SetColor(2) end,
	[3] = function() CritlineSettings_SetColor(3) end,
	[4] = function() CritlineSettings_SetColor(4) end,
	[5] = function() CritlineSettings_SetColor(5) end,
	[6] = function() CritlineSettings_SetColor(6) end
}


function CritlineSettings_ColorPicker(id)
	CloseMenus()
	local texture = _G["CritlineSettings_FrameAdvancedColor"..id.."Swatch"]
	if not texture.a then
		texture.a = 1
	end
	ColorPickerFrame.func = CritlineSettings_SetColorFunc[id]
	ColorPickerFrame:SetColorRGB(texture.r, texture.g, texture.b)
	ColorPickerFrame.previousValues = {r = texture.r, g = texture.g, b = texture.b, opacity =texture.a}
	ColorPickerFrame.cancelFunc = CritlineSettings_CancelFunc[id]
	ColorPickerFrame.hasOpacity = false
	
	ColorPickerFrame:Show()
end


function CritlineSettings_SetColor(id)
	local r, g, b = ColorPickerFrame:GetColorRGB()
	local texture = _G["CritlineSettings_FrameAdvancedColor"..id.."Swatch"]
	--SHTSetOpacity(id)
	texture:SetVertexColor(r, g, b)
	texture.r = r
	texture.g = g
	texture.b = b
	if id == 1 then
		CL_SETTINGS["SPELLCOLOR"]["r"] = r
		CL_SETTINGS["SPELLCOLOR"]["g"] = g
		CL_SETTINGS["SPELLCOLOR"]["b"] = b
	elseif id == 2 then
		CL_SETTINGS["AMOUNTCOLOR"]["r"] = r
		CL_SETTINGS["AMOUNTCOLOR"]["g"] = g
		CL_SETTINGS["AMOUNTCOLOR"]["b"] = b
	end
end


function CritlineSettings_CancelColor(id, prev)
	local texture = _G["CritlineSettings_FrameAdvancedColor"..id.."Swatch"]
	local r = prev.r
	local g = prev.g
	local b = prev.b
	local a = prev.opacity
	texture:SetVertexColor(r, g, b)
	texture:SetAlpha( a )
	texture.r = r
	texture.g = g
	texture.b = b
	texture.a = a
end